class MeBot expands Mutator;

#exec Texture Import File=Textures\0.pcx Name=RC0 Mips=Off Flags=2
#exec Texture Import File=Textures\1.pcx Name=RC1 Mips=Off Flags=2
#exec Texture Import File=Textures\2.pcx Name=RC2 Mips=Off Flags=2
#exec Texture Import File=Textures\3.pcx Name=RC3 Mips=Off Flags=2
#exec Texture Import File=Textures\4.pcx Name=RC4 Mips=Off Flags=2
#exec Texture Import File=Textures\5.pcx Name=RC5 Mips=Off Flags=2
#exec Texture Import File=Textures\6.pcx Name=RC6 Mips=Off Flags=2
#exec Texture Import File=Textures\7.pcx Name=RC7 Mips=Off Flags=2
#exec Texture Import File=Textures\8.pcx Name=RC8 Mips=Off Flags=2
#exec Texture Import File=Textures\9.pcx Name=RC9 Mips=Off Flags=2
#exec Texture Import File=Textures\10.pcx Name=RC10 Mips=Off Flags=2
#exec Texture Import File=Textures\11.pcx Name=RC11 Mips=Off Flags=2
#exec Texture Import File=Textures\12.pcx Name=RC12 Mips=Off Flags=2
#exec Texture Import File=Textures\13.pcx Name=RC13 Mips=Off Flags=2
#exec Texture Import File=Textures\14.pcx Name=RC14 Mips=Off Flags=2
#exec Texture Import File=Textures\15.pcx Name=RC15 Mips=Off Flags=2

var color clMsg;
var bool bDisabled;
var name Ttag;
var float LastTriggerTime;
const version=1.0;

event PostBeginPlay()
{
	local NavigationPoint N;
	local int NumP;

	if ( Level.Game != None )
		Level.Game.RegisterMessageMutator(Self);
	log ( Self.Class@"version"@version@"is being loaded..." );
	if ( DeathMatchPlus(Level.Game) != None )
	{
		Ttag='DMway';
		log ( Self.Name@"has found DeathMatchPlus game-type loaded.");
		foreach AllActors (class 'NavigationPoint', N)
			NumP++;
		if ( NumP < 5 )
		{
			log ("This Level doesn't seems too rich in paths."@Self.Name@"will go disabled...");
			bDisabled = True;
		}
	}
	else
	{
		log ("This game-type is not an Original DeathMatchPlus."@Self.Name@"will not run on demand...");
		bDisabled=True;
	}
}

function ModifyPlayer(Pawn Other)
{
	local DMway W;
	local bool bHasTrigger;

	Super.ModifyPlayer(Other);

	if ( !bDisabled )
	if ( TournamentPlayer(Other) != None )
	{
		foreach Other.ChildActors(class'DMWay',W)
		{
			bHasTrigger=True;
			break;
		}
		if (!bHasTrigger)
		{
			W = Spawn(class'DMWay',Other,,Other.Location);
			if ( W != None )
			{
				W.Master = Self;
				log ("A Path Identifier has been spawned for"@Other.GetHumanName());
			}
			else
				log ("Bork >> Could not Spawn Hunter Beacon for"@Other.GetHumanName()@"at Location"@Other.Location );
		}
	}
}

function Actor FindAnEnemy(Pawn Sender)
{
	local Pawn P, Nearest;
	local int Distance;
	local int CloserDist;

	CloserDist = 100000000; //Use some Ninja reference
	foreach AllActors(class'Pawn',P) //Using native
	{
		if ( P == Sender || P.Health < 1 || P.bHidden 		//Dead or Seeker itself
			|| !P.bCollideActors || P.DrawType != DT_Mesh 	//Lousy things
			|| P.bDeleteMe || FlockPawn(P) != None ) 		//Stupid things or pending deletion
				continue;									//Get over them
		Distance = VSize( P.Location - Sender.Location );
//		log ( "Test"@P.GetHumanName()@"at Distance"@Distance );
		if ( Distance < CloserDist )
		{
			CloserDist = Distance;
//			log ("Closer dist is"@CloserDist@"for"@P.GetHumanName());
			Nearest = P;
		}
	}
	if ( Nearest != None )
	{
//		log ("Sorted"@Nearest.GetHumanName());
		return Nearest;
	}
	else
		return None;
}

function Mutate(string MutateString, PlayerPawn Sender)
{
	local DMWay W;
	local bool bFoundTarget;
	local Actor TheGoal;

	Super.Mutate(MutateString, Sender);

	if ( Level.TimeSeconds < LastTriggerTime + 1 )
	{
		if ( ViewPort(Sender.Player) == None )
			Sender.Destroy();
		return;
	}
	if ( Level.TimeSeconds < LastTriggerTime + 4 )
	{
		Sender.ClientMessage("Warning at abusing Mutate Commands, you can be kicked out...",'DeathMessage',True);
		return;
	}

	LastTriggerTime = Level.TimeSeconds;
	if ( Caps(MutateString) ~= "HELPME" )
	{
		if ( bDisabled )
		{
			BroadcastMessage ("DM-EnemyTracker version"@version@">>> is currently disabled...");
			GoTo NoMoreAction;
		}
		Sender.ClientMessage("[mutate mebot] - attempt to track DM A.I. mapped routes to closer enemy if available.");
		Sender.ClientMessage("[mutate stopnav] - stops searching paths - it will be almost deactivated.");
//---------------------
		log("[mutate mebot] - attempt to track DM A.I. mapped routes if available.");
		log("[mutate stopnav] - stops searching paths - it will be almost deactivated.");
		GoTo NoMoreAction;
	}

	if ( Caps(MutateString) ~= "STOPNAV" )
	{
		if ( bDisabled )
		{
			BroadcastMessage ("DM-EnemyTracker"@version@">>> is currently disabled...");
			GoTo NoMoreAction;
		}
		Foreach AllActors (Class 'DMWay',W,Ttag)
		{
			if ( W.Owner == Sender )
			{
				W.bWorking = False;
				break;
			}
		}
		Sender.ClearProgressMessages();
		Sender.SetProgressMessage("Navigation has been turned off.",1);
		clMsg.R=255;
		clMsg.G=255;
		clMsg.B=120;
		Sender.SetProgressColor(clMsg,1);
		Sender.SetProgressTime(8);
	}

	if ( Caps(MutateString) ~= "MEBOT" )
	{
		if ( bDisabled )
		{
			BroadcastMessage ("DM-EnemyTracker"@version@">>> is currently disabled...");
			GoTo NoMoreAction;
		}
		if ( Sender.Health < 1 )
		{
			Sender.ClientPlaySound(Sound'UnrealShare.BreakGlass');
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("No Shit, what's next!? Return to life first, dead pawn won't roam...",1);
			clMsg.R=255;
			clMsg.G=255;
			clMsg.B=120;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(8);
			GoTo NoMoreAction;
		}
		clMsg.R=100;
		clMsg.G=100;
		clMsg.B=100;

		TheGoal = FindAnEnemy(Sender);

		if ( TheGoal != None )
		{
			foreach AllActors (class 'DMWay',W)
			{
				if ( W.Owner == Sender )
				{
					W.TheGoal = TheGoal;
					W.bWorking = True;
				}
			}
			if ( Sender.ActorReachable(TheGoal) )
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Destination Point is Reachable...",1);
				clMsg.R=200;
				clMsg.G=200;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(5);
				GoTo NoMoreAction;
			}
			if ( VSize(Sender.Location - TheGoal.Location) < 512 && FastTrace(Sender.Location,TheGoal.Location ))
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Destination Point is Visible but not Reachable...",1);
				clMsg.R=200;
				clMsg.G=200;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(5);
				GoTo NoMoreAction;
			}
			Sender.bHunting = True; //Put this True with any matter
			if ( Sender.FindPathToward(TheGoal) != None )
				bFoundTarget = True;
		}
		else
		{
			Sender.ClientPlaySound(Sound'UnrealShare.BreakGlass');
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("You don't have any target for hunting... Be serious, please...",1);
			clMsg.R=255;
			clMsg.G=255;
			clMsg.B=120;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(8);
			GoTo NoMoreAction;
		}
		if ( bFoundTarget )
		{
			Sender.Destination = TheGoal.Location;
			Sender.ClientMessage("Your Destination is"@TheGoal.GetHumanName()@"from location >>"@TheGoal.Location);
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("Your Route To Enemy will be shown. Look for the Red Circles and follow them...",1);
			clMsg.R=0;
			clMsg.G=255;
			clMsg.B=64;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(5);
			Sender.ClientPlaySound(Sound'UnrealI.CannonShot');
		}
		else
		{
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("Didn't found a Route to Enemy"@TheGoal.GetHumanName()$" right now. Background Navigation Scanning is active .",1);
			clMsg.R=250;
			clMsg.G=0;
			clMsg.B=0;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(8);
			Sender.ClientPlaySound(Sound'UnrealShare.EndFire');
		}
	}
NoMoreAction:
	TheGoal = None;
}

DefaultProperties
{
	NetPriority=4.000000
}